package it.unitn.disi.ronchet.esameSettembre21;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public class ManageClassement extends HttpServlet {
    // inner class di supporto ----------------------
    class Record implements Comparable<Record> {

        String nome;
        String points;

        Record(String nome, String points) {
            this.nome = nome;
            this.points = points;
        }

        @Override
        public String toString() {
            return points + " - " + nome;
        }

        @Override
        public int compareTo(Record o) {
            return Integer.parseInt(o.points) - Integer.parseInt(points);
        }
    }
    //-----------------------------------------------
    List<Record> classement;
    // oggetto usato per la sincronizzazione
    final Object token = new Object();
    
    @Override
    public void init() {
        classement = new ArrayList<Record>();
        ServletContext ctx = getServletContext();
        ctx.setAttribute("classement", classement);
        if (ctx.getAttribute("classementView") == null) {
            ctx.setAttribute("classementView", "Classifica vuota - Nessuna partita giocata");
        }
    }

    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        String points = request.getParameter("points");
        String user = (String) (request.getSession().getAttribute("name"));
        Record rec = new Record(user, points);
        ServletContext ctx = request.getServletContext();
        // gestiamo gli accessi concorrenti a classement
        synchronized (token) {
            classement = (List<Record>) (ctx.getAttribute("classement"));
            //System.out.println(classement.size());
            classement.add(rec);
            //System.out.println(classement.size());
            Collections.sort(classement);
            ctx.setAttribute("classement", classement);
            String classementView = new String("<table>");
            for (Record r : classement) {
                classementView=classementView+"\n<tr><td>"+r.toString()+"</td></tr>";
                //classementView.append(r.toString());
                //classementView.append("</td></tr>");
            }
            classementView=classementView+"</table>";
            ctx.setAttribute("classementView", classementView);
        }
        RequestDispatcher rp=request.getRequestDispatcher("index.jsp");
        rp.forward(request, response);
    }
    // metodo doGet messo qui per supportare la versione più semplice.
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        doPost(request,response);
    }
}
